
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import com.sun.image.codec.jpeg.*;

class SaveJpeg {

	public static boolean saveImageFromMemory(ImageProducer ip, String filename, float quality) {
		return saveImage(Toolkit.getDefaultToolkit().createImage(ip),filename,quality);
	}

	public static boolean saveImageFromRGBMemory(int data[], int width, int height, String filename, float quality) {
		ColorModel cm = new DirectColorModel(32,0x00FF0000,0x0000FF00,0x000000FF,0);
		MemoryImageSource mis = new MemoryImageSource(width,height,cm,data,0,width);
		return saveImageFromMemory(mis,filename,quality);
	}

	public static boolean saveImageFromPaletteMemory(int data[], int width, int height, byte red[], byte green[], byte blue[], String filename, float quality) {
		ColorModel cm = new IndexColorModel(8,red.length,red,green,blue);
		MemoryImageSource mis = new MemoryImageSource(width,height,cm,data,0,width);
		return saveImageFromMemory(mis,filename,quality);
	}

	public static boolean saveImage(Image image, String filename, float quality) {

		BufferedImage bi = new BufferedImage(image.getWidth(null),image.getHeight(null),BufferedImage.TYPE_INT_RGB);
		Graphics2D g = bi.createGraphics();
		g.drawImage(image,0,0,null);

		try {
			JPEGImageEncoder jie = JPEGCodec.createJPEGEncoder(new FileOutputStream(filename));
			JPEGEncodeParam jep = jie.getDefaultJPEGEncodeParam(bi);
			if (quality >= 0 && quality <= 1)
				jep.setQuality(quality,true);
/*			for (int i = 0; i < jep.getNumComponents(); i++) {
				jep.setHorizontalSubsampling(i,1);
				jep.setVerticalSubsampling(i,1);
			}
*/			jie.setJPEGEncodeParam(jep);
			jie.encode(bi);
			jie.getOutputStream().close();
		} catch (IOException ioe) {
			System.err.println(ioe);
			return false;
		}

		return true;

	}

}

